#ifndef _SHFS_FCACHE_H_
#define _SHFS_FCACHE_H_

#define SHFS_FCACHE_HASH	10
#define SHFS_FCACHE_PAGES	16	/* should be 2^x */
#define SHFS_FCACHE_SIZE	((unsigned)(SHFS_FCACHE_PAGES * PAGE_SIZE))

#include <linux/slab.h>
#include <linux/kdev_t.h>

extern kmem_cache_t	*file_hash_cache;

#define SHFS_FCACHE_READ  0
#define SHFS_FCACHE_WRITE 1

struct shfs_file {
	int		type;
	unsigned long	ino;
	unsigned	used;
	unsigned 	name_hash;
	unsigned	offset;
	unsigned	count;
	char          	*data;
};

struct shfs_file_hash_node {
	struct shfs_file_hash_node *prev, *next;
	struct shfs_file buf;
};

struct shfs_file_cache {
	struct shfs_file_hash_node *hash[SHFS_FCACHE_HASH];
	unsigned len[SHFS_FCACHE_HASH];
};

struct shfs_sb_info;

void shfs_fcache_init(struct shfs_sb_info*);
int shfs_fcache_empty(struct shfs_sb_info*);
int shfs_fcache_add(struct file*);
int shfs_fcache_remove(struct file*);
int shfs_fcache_sync(struct file*);
int shfs_fcache_read(struct dentry*, unsigned, unsigned, char*);
int shfs_fcache_write(struct dentry*, unsigned, unsigned, char*);

#endif	/* _SHFS_FCACHE_H_ */
